Index: /palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init.f90	(revision 1928)
+++ /palm/trunk/SOURCE/lpm_init.f90	(revision 1929)
@@ -19,5 +19,10 @@
 ! Current revisions:
 ! -----------------
-!
+! Bugfix in determining initial particle height and grid index in case of 
+! seed_follows_topography.
+! Bugfix concerning random positions, ensure that particles do not move more 
+! than one grid length.
+! Bugfix logarithmic interpolation.
+! Initial setting of sgs_wf_part.
 ! 
 ! Former revisions:
@@ -31,5 +36,6 @@
 !
 ! 1873 2016-04-18 14:50:06Z maronga
-! Module renamed (removed _mod)
+! Module renamed (removed _mod
+
 ! 
 ! 1871 2016-04-15 11:46:09Z hoffmann
@@ -162,5 +168,5 @@
                 prt_count, psb, psl, psn, psr, pss, pst,                       &
                 radius, random_start_position, read_particles_from_restartfile,&
-                seed_follows_topography, sort_count,                           &
+                seed_follows_topography, sgs_wf_part, sort_count,              &
                 total_number_of_particles,                                     &
                 use_sgs_for_particles,                                         &
@@ -190,5 +196,5 @@
     PUBLIC lpm_init, lpm_create_particle
 
-CONTAINS
+ CONTAINS
 
 !------------------------------------------------------------------------------!
@@ -290,9 +296,12 @@
 
 !
-!-- Allocate arrays required for calculating particle SGS velocities
+!-- Allocate arrays required for calculating particle SGS velocities. 
+!-- Initialize prefactor required for stoachastic Weil equation.
     IF ( use_sgs_for_particles  .AND.  .NOT. cloud_droplets )  THEN
        ALLOCATE( de_dx(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
                  de_dy(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
                  de_dz(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+
+       sgs_wf_part = 1.0_wp / 3.0_wp    
     ENDIF
 
@@ -334,5 +343,5 @@
 !
 !--    Precalculate LOG(z/z0)
-       height_p    = 0.0_wp
+       height_p    = z0_av_global
        DO  k = 1, number_of_sublayers
 
@@ -341,5 +350,4 @@
 
        ENDDO
-
 
     ENDIF
@@ -444,5 +452,5 @@
                                       0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp,  &
                                       0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0, 0, 0, &
-                                      0, .FALSE., -1)
+                                      0, .FALSE., -1 )
 
        particle_groups = particle_groups_type( 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp )
@@ -477,5 +485,4 @@
 
        CALL lpm_create_particle (PHASE_INIT)
-
 !
 !--    User modification of initial particles
@@ -499,5 +506,4 @@
     number_of_particles = prt_count(nzb+1,nys,nxl)
     particles => grid_particles(nzb+1,nys,nxl)%particles(1:number_of_particles)
-
 !
 !-- Formats
@@ -520,30 +526,31 @@
 
     USE particle_attributes,                                                   &
-        ONLY: monodisperse_aerosols
+        ONLY: deleted_particles, monodisperse_aerosols
 
     IMPLICIT  NONE
 
-    INTEGER(iwp)               ::  alloc_size  !<
-    INTEGER(iwp)               ::  i           !<
-    INTEGER(iwp)               ::  ip          !<
-    INTEGER(iwp)               ::  j           !<
-    INTEGER(iwp)               ::  jp          !<
-    INTEGER(iwp)               ::  kp          !<
-    INTEGER(iwp)               ::  loop_stride !<
-    INTEGER(iwp)               ::  n           !<
-    INTEGER(iwp)               ::  new_size    !<
-
-    INTEGER(iwp), INTENT(IN)   ::  phase       !<
-
-    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  local_count !<
-    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  local_start !<
-
-    LOGICAL                    ::  first_stride !<
-
-    REAL(wp)                   ::  pos_x !<
-    REAL(wp)                   ::  pos_y !<
-    REAL(wp)                   ::  pos_z !<
-
-    TYPE(particle_type),TARGET ::  tmp_particle !<
+    INTEGER(iwp)               ::  alloc_size  !< relative increase of allocated memory for particles
+    INTEGER(iwp)               ::  i           !< loop variable ( particle groups )
+    INTEGER(iwp)               ::  ip          !< index variable along x
+    INTEGER(iwp)               ::  j           !< loop variable ( particles per point )
+    INTEGER(iwp)               ::  jp          !< index variable along y
+    INTEGER(iwp)               ::  kp          !< index variable along z
+    INTEGER(iwp)               ::  loop_stride !< loop variable for initialization
+    INTEGER(iwp)               ::  n           !< loop variable ( number of particles )
+    INTEGER(iwp)               ::  new_size    !< new size of allocated memory for particles
+
+    INTEGER(iwp), INTENT(IN)   ::  phase       !< mode of inititialization
+
+    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  local_count !< start address of new particle
+    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  local_start !< start address of new particle
+
+    LOGICAL                    ::  first_stride !< flag for initialization
+
+    REAL(wp)                   ::  pos_x      !< increment for particle position in x      
+    REAL(wp)                   ::  pos_y      !< increment for particle position in y  
+    REAL(wp)                   ::  pos_z      !< increment for particle position in z     
+    REAL(wp)                   ::  rand_contr !< dummy argument for random position
+
+    TYPE(particle_type),TARGET ::  tmp_particle !< temporary particle used for initialization
 
 !
@@ -618,4 +625,5 @@
                             tmp_particle%tail_id       = 0     !unused
 
+
 !
 !--                         Determine the grid indices of the particle position
@@ -628,9 +636,14 @@
 !--                            Particle height is given relative to topography
                                kp = kp + nzb_w_inner(jp,ip)
-                               tmp_particle%z = tmp_particle%z + zw(kp)
+                               tmp_particle%z = tmp_particle%z +               &
+                                                         zw(nzb_w_inner(jp,ip))
                                IF ( kp > nzt )  THEN
                                   pos_x = pos_x + pdx(i)
                                   CYCLE xloop
                                ENDIF
+                            ELSEIF ( .NOT. seed_follows_topography .AND.       &
+                                     tmp_particle%z <= zw(nzb_w_inner(jp,ip)) )  THEN
+                               pos_x = pos_x + pdx(i)
+                               CYCLE xloop                               
                             ENDIF
 
@@ -644,4 +657,5 @@
                                ENDIF
                                grid_particles(kp,jp,ip)%particles(local_count(kp,jp,ip)) = tmp_particle
+
                             ENDIF
                          ENDDO
@@ -691,8 +705,10 @@
                       ENDIF
                    ENDIF
+
                 ENDDO
              ENDDO
           ENDDO
        ENDIF
+
     ENDDO
 
@@ -707,5 +723,5 @@
 
 !
-!-- Add random fluctuation to particle positions
+!-- Add random fluctuation to particle positions.
     IF ( random_start_position )  THEN
        DO  ip = nxl, nxr
@@ -715,25 +731,54 @@
                 IF ( number_of_particles <= 0 )  CYCLE
                 particles => grid_particles(kp,jp,ip)%particles(1:number_of_particles)
-
-                DO  n = local_start(kp,jp,ip), number_of_particles              !Move only new particles
+!
+!--             Move only new particles. Moreover, limit random fluctuation 
+!--             in order to prevent that particles move more than one grid box, 
+!--             which would lead to problems concerning particle exchange 
+!--             between processors in case pdx/pdy are larger than dx/dy, 
+!--             respectively.  
+                DO  n = local_start(kp,jp,ip), number_of_particles
                    IF ( psl(particles(n)%group) /= psr(particles(n)%group) )  THEN
+                      rand_contr = ( random_function( iran_part ) - 0.5_wp ) * &
+                                     pdx(particles(n)%group)
                       particles(n)%x = particles(n)%x +                        &
-                                   ( random_function( iran_part ) - 0.5_wp ) * &
-                                   pdx(particles(n)%group)
+                              MERGE( rand_contr, SIGN( dx, rand_contr ), &
+                                     ABS( rand_contr ) < dx                    &
+                                   ) 
                    ENDIF
                    IF ( pss(particles(n)%group) /= psn(particles(n)%group) )  THEN
+                      rand_contr = ( random_function( iran_part ) - 0.5_wp ) * &
+                                     pdy(particles(n)%group)
                       particles(n)%y = particles(n)%y +                        &
-                                   ( random_function( iran_part ) - 0.5_wp ) * &
-                                   pdy(particles(n)%group)
+                              MERGE( rand_contr, SIGN( dy, rand_contr ), &
+                                     ABS( rand_contr ) < dy                    &
+                                   ) 
                    ENDIF
                    IF ( psb(particles(n)%group) /= pst(particles(n)%group) )  THEN
+                      rand_contr = ( random_function( iran_part ) - 0.5_wp ) * &
+                                     pdz(particles(n)%group)
                       particles(n)%z = particles(n)%z +                        &
-                                   ( random_function( iran_part ) - 0.5_wp ) * &
-                                   pdz(particles(n)%group)
+                              MERGE( rand_contr, SIGN( dz, rand_contr ), &
+                                     ABS( rand_contr ) < dz                    &
+                                   ) 
                    ENDIF
                 ENDDO
 !
-!--             Identify particles located outside the model domain
+!--             Identify particles located outside the model domain and reflect
+!--             or absorb them if necessary.
                 CALL lpm_boundary_conds( 'bottom/top' )
+!
+!--             Furthermore, remove particles located in topography. Note, as
+!--             the particle speed is still zero at this point, wall 
+!--             reflection boundary conditions will not work in this case.
+                particles =>                                                   &
+                       grid_particles(kp,jp,ip)%particles(1:number_of_particles)
+                DO  n = local_start(kp,jp,ip), number_of_particles
+                   i = ( particles(n)%x + 0.5_wp * dx ) * ddx
+                   j = ( particles(n)%y + 0.5_wp * dy ) * ddy
+                   IF ( particles(n)%z <= zw(nzb_w_inner(j,i)) )  THEN
+                      particles(n)%particle_mask = .FALSE.
+                      deleted_particles = deleted_particles + 1
+                   ENDIF
+                ENDDO
              ENDDO
           ENDDO
Index: /palm/trunk/SOURCE/lpm_init_sgs_tke.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init_sgs_tke.f90	(revision 1928)
+++ /palm/trunk/SOURCE/lpm_init_sgs_tke.f90	(revision 1929)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-!
+! sgs_wfu_par, sgs_wfv_par and sgs_wfw_par are replaced by sgs_wf_par
 ! 
 ! Former revisions:
@@ -72,5 +72,5 @@
 
     USE particle_attributes,                                                   &
-        ONLY:  sgs_wfu_part, sgs_wfv_part, sgs_wfw_part
+        ONLY:  sgs_wf_part
 
     USE pegrid
@@ -95,10 +95,10 @@
                   k  > nzb_s_inner(j,i+1) )                                    &
              THEN
-                de_dx(k,j,i) = 2.0_wp * sgs_wfu_part *                         &
+                de_dx(k,j,i) = 2.0_wp * sgs_wf_part *                          &
                                ( e(k,j,i+1) - e(k,j,i) ) * ddx
              ELSEIF ( k  > nzb_s_inner(j,i-1)  .AND.  k > nzb_s_inner(j,i)     &
                       .AND.  k <= nzb_s_inner(j,i+1) )                         &
              THEN
-                de_dx(k,j,i) = 2.0_wp * sgs_wfu_part *                         &
+                de_dx(k,j,i) = 2.0_wp * sgs_wf_part *                          &
                                ( e(k,j,i) - e(k,j,i-1) ) * ddx
              ELSEIF ( k < nzb_s_inner(j,i)  .AND.  k < nzb_s_inner(j,i+1) )    &
@@ -109,5 +109,5 @@
                 de_dx(k,j,i) = 0.0_wp
              ELSE
-                de_dx(k,j,i) = sgs_wfu_part * ( e(k,j,i+1) - e(k,j,i-1) ) * ddx
+                de_dx(k,j,i) = sgs_wf_part * ( e(k,j,i+1) - e(k,j,i-1) ) * ddx
              ENDIF
 
@@ -115,10 +115,10 @@
                   k  > nzb_s_inner(j+1,i) )                                    &
              THEN
-                de_dy(k,j,i) = 2.0_wp * sgs_wfv_part *                         &
+                de_dy(k,j,i) = 2.0_wp * sgs_wf_part *                          &
                                ( e(k,j+1,i) - e(k,j,i) ) * ddy
              ELSEIF ( k  > nzb_s_inner(j-1,i)  .AND.  k  > nzb_s_inner(j,i)    &
                       .AND.  k <= nzb_s_inner(j+1,i) )                         &
              THEN
-                de_dy(k,j,i) = 2.0_wp * sgs_wfv_part *                         &
+                de_dy(k,j,i) = 2.0_wp * sgs_wf_part *                          &
                                ( e(k,j,i) - e(k,j-1,i) ) * ddy
              ELSEIF ( k < nzb_s_inner(j,i)  .AND.  k < nzb_s_inner(j+1,i) )    &
@@ -129,5 +129,5 @@
                 de_dy(k,j,i) = 0.0_wp
              ELSE
-                de_dy(k,j,i) = sgs_wfv_part * ( e(k,j+1,i) - e(k,j-1,i) ) * ddy
+                de_dy(k,j,i) = sgs_wf_part * ( e(k,j+1,i) - e(k,j-1,i) ) * ddy
              ENDIF
 
@@ -142,5 +142,5 @@
 
           DO  k = nzb_s_inner(j,i)+2, nzt-1
-             de_dz(k,j,i)  = 2.0_wp * sgs_wfw_part *                           &
+             de_dz(k,j,i)  = 2.0_wp * sgs_wf_part *                            &
                              ( e(k+1,j,i) - e(k-1,j,i) ) / ( zu(k+1)-zu(k-1) )
           ENDDO
@@ -148,5 +148,5 @@
           k = nzb_s_inner(j,i)
           de_dz(nzb:k,j,i) = 0.0_wp
-          de_dz(k+1,j,i)   = 2.0_wp * sgs_wfw_part *                           &
+          de_dz(k+1,j,i)   = 2.0_wp * sgs_wf_part *                            &
                              ( e(k+2,j,i) - e(k+1,j,i) ) / ( zu(k+2) - zu(k+1) )
           de_dz(nzt,j,i)   = 0.0_wp
Index: /palm/trunk/SOURCE/mod_particle_attributes.f90
===================================================================
--- /palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 1928)
+++ /palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 1929)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-!
+! -sgs_wfu_par, sgs_wfv_par, sgs_wfw_par
+! + sgs_wf_par
 !
 ! Former revisions:
@@ -109,7 +110,5 @@
                  initial_weighting_factor = 1.0_wp,                            &
                  particle_advection_start = 0.0_wp,                            &
-                 sgs_wfu_part = 0.3333333_wp, sgs_wfv_part = 0.3333333_wp,     &
-                 sgs_wfw_part = 0.3333333_wp, time_prel = 0.0_wp,              &
-                 time_sort_particles = 0.0_wp,                                 &
+                 sgs_wf_part, time_prel = 0.0_wp, time_sort_particles = 0.0_wp,&
                  time_write_particle_data = 0.0_wp, z0_av_global
 
Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 1928)
+++ /palm/trunk/SOURCE/pres.f90	(revision 1929)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-!
+! Bugfix: weight_substep for initial call, replace by local variable
 !
 ! Former revisions:
@@ -162,4 +162,5 @@
     REAL(wp)     ::  threadsum      !<
     REAL(wp)     ::  weight_pres_l  !<
+    REAL(wp)     ::  weight_substep_l !<
 
     REAL(wp), DIMENSION(1:3)   ::  volume_flow_l       !<
@@ -178,9 +179,11 @@
 !
 !--    If pres is called before initial time step
-       weight_pres_l = 1.0_wp
-       d_weight_pres = 1.0_wp
+       weight_pres_l    = 1.0_wp
+       d_weight_pres    = 1.0_wp
+       weight_substep_l = 1.0_wp
     ELSE
-       weight_pres_l = weight_pres(intermediate_timestep_count)
-       d_weight_pres = 1.0_wp / weight_pres(intermediate_timestep_count)
+       weight_pres_l    = weight_pres(intermediate_timestep_count)
+       d_weight_pres    = 1.0_wp / weight_pres(intermediate_timestep_count)
+       weight_substep_l = weight_substep(intermediate_timestep_count)
     ENDIF
 
@@ -591,5 +594,5 @@
        !$OMP PARALLEL PRIVATE (i,j,k)
        !$OMP DO
-       !$acc kernels present( p, tend, weight_substep )
+       !$acc kernels present( p, tend, weight_substep_l )
        !$acc loop independent
        DO  i = nxl-1, nxr+1
@@ -599,5 +602,5 @@
              DO  k = nzb, nzt+1
                 p(k,j,i) = tend(k,j,i) * &
-                           weight_substep(intermediate_timestep_count)
+                           weight_substep_l
              ENDDO
           ENDDO
@@ -609,5 +612,5 @@
        !$OMP PARALLEL PRIVATE (i,j,k)
        !$OMP DO
-       !$acc kernels present( p, tend, weight_substep )
+       !$acc kernels present( p, tend, weight_substep_l )
        !$acc loop independent
        DO  i = nxl-1, nxr+1
@@ -617,5 +620,5 @@
              DO  k = nzb, nzt+1
                 p(k,j,i) = p(k,j,i) + tend(k,j,i) * &
-                           weight_substep(intermediate_timestep_count)
+                           weight_substep_l
              ENDDO
           ENDDO
Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 1928)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 1929)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Bugfix: avoid segmentation fault in case one grid point is horizontally 
+! completely surrounded by topography 
 ! 
 ! Former revisions:
@@ -726,6 +727,8 @@
 !--             consequence would result in very large shear stresses and very
 !--             small momentum fluxes (both are generally unrealistic).
-                IF ( ( z_mo / ol(j,i) ) < zeta_min )  ol(j,i) = z_mo / zeta_min
-                IF ( ( z_mo / ol(j,i) ) > zeta_max )  ol(j,i) = z_mo / zeta_max
+                IF ( ( z_mo / ( ol(j,i) + 1E-30_wp ) ) < zeta_min )            &
+                   ol(j,i) = z_mo / zeta_min
+                IF ( ( z_mo / ( ol(j,i) + 1E-30_wp ) ) > zeta_max )            &
+                   ol(j,i) = z_mo / zeta_max
              ENDDO
           ENDDO
Index: /palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 1928)
+++ /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 1929)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Bugfix: added preprocessor directives for parallel and serial mode
 ! 
 ! Former revisions:
@@ -2058,5 +2058,6 @@
 
 !
-!--          Transfer of information to the other cpus            
+!--          Transfer of information to the other cpus
+#if defined( __parallel )         
              CALL MPI_ALLREDUCE( u_inflow_l, u_inflow, nturbines, MPI_REAL,    &
                                  MPI_SUM, comm2d, ierr )
@@ -2065,5 +2066,9 @@
              CALL MPI_ALLREDUCE( phi_yaw_l, phi_yaw, nturbines, MPI_REAL,      &
                                  MPI_SUM, comm2d, ierr )
-             
+#else
+             u_inflow = u_inflow_l
+             wdir     = wdir_l
+             phi_yaw  = phi_yaw_l
+#endif
              DO inot = 1, nturbines
 !             
@@ -2080,4 +2085,5 @@
 !              CALL MPI_ALLREDUCE( omega_gen, omega_gen_old, nturbines,        &
 !                                  MPI_REAL,MPI_SUM, comm2d, ierr )
+#if defined( __parallel )    
              CALL MPI_ALLREDUCE( torque_gen, torque_gen_old, nturbines,        &
                                  MPI_REAL, MPI_SUM, comm2d, ierr )
@@ -2086,4 +2092,9 @@
              CALL MPI_ALLREDUCE( omega_gen_f, omega_gen_f_old, nturbines,      &
                                  MPI_REAL, MPI_SUM, comm2d, ierr )
+#else
+             torque_gen_old  = torque_gen
+             omega_rot       = omega_rot_l
+             omega_gen_f_old = omega_gen_f
+#endif
             
           ENDIF
